org.apache.commons.math3.ode.nonstiff

## Class EulerIntegrator

- java.lang.Object
- - org.apache.commons.math3.ode.AbstractIntegrator
  - - org.apache.commons.math3.ode.nonstiff.RungeKuttaIntegrator
    - - org.apache.commons.math3.ode.nonstiff.EulerIntegrator

- All Implemented Interfaces:
    FirstOrderIntegrator, ODEIntegrator

      public class EulerIntegrator
      extends RungeKuttaIntegrator

  This class implements a simple Euler integrator for Ordinary Differential Equations.

  The Euler algorithm is the simplest one that can be used to integrate ordinary differential equations. It is a simple inversion of the forward difference expression : `f'=(f(t+h)-f(t))/h` which leads to `f(t+h)=f(t)+hf'`. The interpolation scheme used for dense output is the linear scheme already used for integration.

  This algorithm looks cheap because it needs only one function evaluation per step. However, as it uses linear estimates, it needs very small steps to achieve high accuracy, and small steps lead to numerical errors and instabilities.

  This algorithm is almost never used and has been included in this package only as a comparison reference for more useful integrators.

  Since:
    1.2
  Version:
    $Id: EulerIntegrator.java 1416643 2012-12-03 19:37:14Z tn $
  See Also:
    `MidpointIntegrator`, `ClassicalRungeKuttaIntegrator`, `GillIntegrator`, `ThreeEighthesIntegrator`

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `private static double[][]` | `STATIC_A` Internal weights Butcher array.
    `private static double[]` | `STATIC_B` Propagation weights Butcher array.
    `private static double[]` | `STATIC_C` Time steps Butcher array.

    - ### Fields inherited from class org.apache.commons.math3.ode.AbstractIntegrator

      `isLastStep, resetOccurred, stepHandlers, stepSize, stepStart`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `EulerIntegrator(double step)` Simple constructor.

  - ### Method Summary

    - ### Methods inherited from class org.apache.commons.math3.ode.nonstiff.RungeKuttaIntegrator

      `integrate`

    - ### Methods inherited from class org.apache.commons.math3.ode.AbstractIntegrator

      `acceptStep, addEventHandler, addEventHandler, addStepHandler, clearEventHandlers, clearStepHandlers, computeDerivatives, getCurrentSignedStepsize, getCurrentStepStart, getEvaluations, getEventHandlers, getMaxEvaluations, getName, getStepHandlers, initIntegration, integrate, sanityChecks, setEquations, setMaxEvaluations, setStateInitialized`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### STATIC_C

          private static final double[] STATIC_C

      Time steps Butcher array.

    - #### STATIC_A

          private static final double[][] STATIC_A

      Internal weights Butcher array.

    - #### STATIC_B

          private static final double[] STATIC_B

      Propagation weights Butcher array.

  - ### Constructor Detail

    - #### EulerIntegrator

          public EulerIntegrator(double step)

      Simple constructor. Build an Euler integrator with the given step.
      Parameters:
        `step` - integration step

Copyright (c) 2003-2013 Apache Software Foundation